// 001 u_c_array_of_double_2
// 30 jun 2007

// -- (C) John COLIBRI 2007
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_array_of_double_2;
  interface
    const k_granularity= 4;

    type c_array_of_double_2= Class
                                public
                                  m_array_of_double: ARRAY of Double;
                                private
                                  // m_array_of_double: ARRAY of Double;
                                  m_count: Integer;

                                  function get_double(p_index: Integer): Double;
                                  procedure set_double(p_index: Integer; p_double: Double);
                                public
                                  Constructor create;
                                  procedure add_double(p_double: Double);

                                  procedure set_length(p_length: Integer);

                                  Destructor Destroy; Override;

                                  Property Doubles[p_index: Integer] : Double read get_double write set_double; Default;
                                  Property Count: Integer read m_count write m_count;
                              end; // c_array_of_double

  implementation
    Uses SysUtils, u_c_display;

    Constructor c_array_of_double_2.create;
      begin
        InHerited Create;
        SetLength(m_array_of_double, k_granularity);
      end; // create

    procedure c_array_of_double_2.add_double(p_double: Double);
      begin
        if m_count>= Length(m_array_of_double)
          then SetLength(m_array_of_double, 2* Length(m_array_of_double));

        m_array_of_double[m_count]:= p_double;
        Inc(m_count);
      end; // add_double

    function c_array_of_double_2.get_double(p_index: Integer): Double;
      begin
        if p_index>= Length(m_array_of_double)
          then Raise Exception.Create('p_index> m_count');

        Result:= m_array_of_double[p_index];
      end; // get_double

    procedure c_array_of_double_2.set_double(p_index: Integer; p_double: Double);
      begin
        if p_index>= Length(m_array_of_double)
          // then Raise Exception.Create('p_index> m_count');
          then begin
              display('array['+ IntTostr(p_index)+ ']:= '+ FloatTostr(p_double));
              m_count:= p_index+ 1;
              SetLength(m_array_of_double, m_count);
            end;  

        // -- if between m_count and Length, readjust m_count
        if p_index>= m_count
          then m_count:= p_index+ 1;

        m_array_of_double[p_index]:= p_double;
      end; // set_double

    procedure c_array_of_double_2.set_length(p_length: Integer);
      begin
        m_array_of_double:= Nil;

        m_count:= p_length;
        SetLength(m_array_of_double, m_count);
      end; // set_length

    Destructor c_array_of_double_2.destroy;
      begin
        m_array_of_double:= Nil;

        Inherited;
      end; // destroy

end.
