// 002 u_21_f_array_of_doubles
// 01 jul 2007

// -- (C) John COLIBRI 2007
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_21_f_array_of_doubles;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    create_array: TButton;
    add_doubles: TButton;
    display_doubles: TButton;
    add_doubles_2: TButton;
    display_doubles_2: TButton;
    free_double: TButton;
    create_arrays: TButton;
    free_doubles_2: TButton;
    procedure create_arrayClick(Sender: TObject);
    procedure add_doublesClick(Sender: TObject);
    procedure display_doublesClick(Sender: TObject);
    procedure add_doubles_2Click(Sender: TObject);
    procedure display_doubles_2Click(Sender: TObject);
    procedure free_doubleClick(Sender: TObject);
    procedure create_arraysClick(Sender: TObject);
    procedure free_doubles_2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display
        , u_c_array_of_record_of_doubles
        , u_c_record_of_array_of_double
        , u_c_array_of_double_2;

    {$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // form_create

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    var g_c_array_of_record_of_doubles: c_array_of_record_of_doubles= Nil;

    procedure TForm1.create_arrayClick(Sender: TObject);
      begin
        g_c_array_of_record_of_doubles:= c_array_of_record_of_doubles.Create;
      end; // create_arrayClick

    procedure TForm1.add_doublesClick(Sender: TObject);
      begin
        if g_c_array_of_record_of_doubles= Nil
          then g_c_array_of_record_of_doubles.Create;

        g_c_array_of_record_of_doubles.add_doubles(f_double_record(1.1, 2.2, 3.3));
        g_c_array_of_record_of_doubles.add_doubles(f_double_record(10.1, 20.2, 30.3));
        g_c_array_of_record_of_doubles.add_doubles(f_double_record(100.1, 200.2, 300.3));

        // -- not allowed
        // g_c_array_of_record_of_doubles.Doubles[3].m_x:= 3.14;
        g_c_array_of_record_of_doubles.Doubles[3]:= f_double_record(3.14, 0, 0);
        g_c_array_of_record_of_doubles.X[4]:= 6.28;
      end; // add_doubles_Click

    procedure TForm1.display_doublesClick(Sender: TObject);
      var l_index: Integer;
      begin
        for l_index:= 0 to g_c_array_of_record_of_doubles.Count- 1 do
          with g_c_array_of_record_of_doubles[l_index] do
            display(Format('x = %5.2f,   y =%5.1f,  z =%5.1f ', [m_x, m_y, m_z]));
      end; // display_doubles_Click

    procedure TForm1.free_doubleClick(Sender: TObject);
      begin
        FreeAndNil(g_c_array_of_record_of_doubles);
      end; // free_double_Click

    var g_c_record_of_array_of_doubles: t_double_record;

    procedure TForm1.create_arraysClick(Sender: TObject);
      begin
        display('create 3 arrays');
        with g_c_record_of_array_of_doubles do
        begin
          m_c_x_array:= c_array_of_double_2.Create;
          m_c_y_array:= c_array_of_double_2.Create;
          m_c_z_array:= c_array_of_double_2.Create;
        end; // with g_c_record_of_array_of_doubles
      end; // create_array_2Click

    procedure TForm1.add_doubles_2Click(Sender: TObject);
      begin
        display('add to 3 arrays');
        with g_c_record_of_array_of_doubles do
        begin
          m_c_x_array[0]:= 1.1;
          m_c_y_array[0]:= 2.2;
          m_c_z_array[0]:= 3.3;

          m_c_x_array[1]:= 10.1;
          m_c_y_array[1]:= 20.2;
          m_c_z_array[1]:= 30.3;
        end; // with g_c_record_of_array_of_doubles
      end; // add_double_property_Click

    procedure TForm1.display_doubles_2Click(Sender: TObject);
      var l_index: Integer;
      begin
        display('display 3 arrays '+ IntToStr(g_c_record_of_array_of_doubles.m_c_x_array.Count));
        with g_c_record_of_array_of_doubles do
        begin
          for l_index:= 0 to m_c_x_array.Count- 1 do
            display(Format('x= %5.1f,  y =%5.1f,  z =%5.1f ',
                [  m_c_x_array[l_index], m_c_y_array[l_index], m_c_z_array[l_index] ]));
        end; // with g_c_record_of_array_of_doubles
      end; // display_double_property_Click

    procedure TForm1.free_doubles_2Click(Sender: TObject);
      begin
        with g_c_record_of_array_of_doubles do
        begin
          FreeAndNil(m_c_x_array);
          FreeAndNil(m_c_y_array);
          FreeAndNil(m_c_z_array);
        end; // with g_c_record_of_array_of_doubles
      end; // free_double_2Click


end.
